#43 Remove redundant check of ssdp source port

closed-accepted
General (2)
5
2011-06-25
2011-06-20
No

Some clients may use priveleged ports or port 1900 as source port when sending SSDP requests. For example, grilo (gnome media discovery framework) sends requests from port 1900 and minidlna completely ignores it:

[2011/06/21 00:24:53] minissdp.c:609: info: WARNING: Ignoring invalid SSDP M-SEARCH from 127.0.0.1 [bad source port 1900]
[2011/06/21 00:24:53] minissdp.c:609: info: WARNING: Ignoring invalid SSDP M-SEARCH from 172.16.25.113 [bad source port 1900]
[2011/06/21 00:24:53] minissdp.c:609: info: WARNING: Ignoring invalid SSDP M-SEARCH from 172.16.25.97 [bad source port 1900]

Discussion

  • Justin Maggard

    Justin Maggard - 2011-06-22

    They shouldn't be, according to the spec. I suppose we could make this controllable using the strict DLNA flag though.

     
  • Justin Maggard

    Justin Maggard - 2011-06-22
    • assigned_to: nobody --> jmaggard
     
  • Ivan Mironov

    Ivan Mironov - 2011-06-22

    I think that this doesn't make sense because disabling this check should not break compatibility with already supported clients, but enabling breaks some other clients. I also found device affected by this issue: iconBIT HD40NMT (this is clone of Popcorn Hour A-110 / Egreat EG-M34A). Other hardware based on Networked Media Tank firmware may also be affected.

    May be minidlna should just write warning to logfile and should not ignore packets with invalid source port? See updated patch.

     
  • Justin Maggard

    Justin Maggard - 2011-06-23

    You're right of course. However, in the past DLNA testing would fail if you responded to SSDP requests from port 1900. And it certainly violates the spec for the client to send from those ports. So, at least for grilo, they should fix that.

    I checked in a change that will only ignore requests from bad source ports if the strict DLNA flag is set. Since the flag is not set by default, that should satisfy the need to have the best compatibility in the default mode.

     
  • Ivan Mironov

    Ivan Mironov - 2011-06-24

    > You're right of course. However, in the past DLNA testing would fail if
    > you responded to SSDP requests from port 1900. And it certainly violates
    > the spec for the client to send from those ports. So, at least for grilo,
    > they should fix that.

    Ok. Please, tell me what exact parts of specification violates by client, that sends requests from priveleged ports or port 1900? I need something like "UPnP Blah Blah Spec v1.1, section 4.2" =). And then I will send appropriate bugreports to developers of Grilo and NMT.

    > I checked in a change that will only ignore requests from bad source ports
    > if the strict DLNA flag is set. Since the flag is not set by default, that
    > should satisfy the need to have the best compatibility in the default mode.

    Thanks alot!

     
  • Justin Maggard

    Justin Maggard - 2011-06-24

    Sure, the specific requirement that is violated is in the DLNA Guidelines, Requirement 7.2.3.4. Thanks for taking care of that!

     
  • Justin Maggard

    Justin Maggard - 2011-06-24
    • labels: --> General
    • status: open --> closed-accepted
     
  • Ivan Mironov

    Ivan Mironov - 2011-06-24
    • status: closed-accepted --> open-accepted
     
  • Ivan Mironov

    Ivan Mironov - 2011-06-25
    • status: open-accepted --> closed-accepted
     

Get latest updates about Open Source Projects, Conferences and News.

Sign up for the SourceForge newsletter:





No, thanks